
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>platform总线驱动代码分析 / 憋错料</title>

    <meta name="description" content="platform总线驱动代码分析 /************************************************************************/ Linux内核版本:2.6.35.7 运行平台:三星s5pv210 /************************************************************************/ 1.本例中通过使用Linux驱动模型中的platform总线和led驱动框架编写出来的led驱动代码来分析platform总线的工作">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">platform总线驱动代码分析</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>/************************************************************************/</p>
<p>Linux内核版本：2.6.35.7</p>
<p>运行平台：三星s5pv210</p>
<p>/************************************************************************/</p>
<p>1、本例中通过使用Linux驱动模型中的platform总线和led驱动框架编写出来的led驱动代码来分析platform总线的工作原理，本代码是我自己将近快一天的时间编写出来的，</p>
<p>已经通过运行验证代码是能够正常运行的。对此对代码做如下分析：</p>
<p>在platform总线（任意总线）下的驱动代码都是要分为两部分：设备和驱动，在platform总线下是platform_device和platform_driver。</p>
<p>关于这个问题，我在我的上一篇博客中已经做了很好的说明。对于设备部分的注册：</p>
<p>(1)一般是内核的移植工程师在做移植的时候添加的，在我的这个移植好的内核中是放在arch/arm/mach-s5pv210/mach-x210.c文件中，</p>
<p>所以如果移植工程师没有添加你需要编写的驱动对应的设备，那么就需要你自己添加，你可以直接在这个文件中添加，系统启动的时候就会</p>
<p>直接加载这个文件的代码，所以设备就会被注册到我们的platform总线下，那么就会添加到platform总线管理下的device设备管理相关的数</p>
<p>据结构中去（链表），此时platform总线下的match函数就会自动进行匹配（每注册一个设备或者驱动match函数都会被调用），因为此时还</p>
<p>相应的驱动笨哦注册，所以匹配肯定是失败的；当我们把驱动也注册之后，也会把驱动添加到platform总线管理下的drive驱动管理相关的数据</p>
<p>结构中去（也是一个链表），platform总线将会再次执行match函数，此时match函数就会匹配成功，platform总线下的设备和驱动就建立了对应</p>
<p>关系了，那么设备就能够工作了。</p>
<p>(2)设备注册部分也可以单独编写， 我们下驱动的时候提供 xxxxx_device.c（用来编写设备部分）和xxx_driver（用来编写驱动部分），将他们</p>
<p>编译成模块，系统启动之后分别使用insmod装载设备和驱动（顺序无所谓）。这种情况一般使用在调试阶段，如果确定我们的驱动是没有bug的情况下</p>
<p>，最好还是把驱动编译进内核，把他们放在他们应该在的位置。</p>
<p>2、led驱动代码</p>
<p>本例子采用的是单独编写编译的方式，代码分析如下：</p>
<p>(1)设备部分：leds-x210-device.c</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuYmxvZ3MuY29tL091dGxpbmluZ0luZGljYXRvcnMvQ29udHJhY3RlZEJsb2NrLmdpZg==.jpg"><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuYmxvZ3MuY29tL091dGxpbmluZ0luZGljYXRvcnMvRXhwYW5kZWRCbG9ja1N0YXJ0LmdpZg==.jpg"></p>

<pre>  1 #include &lt;linux/module.h&gt;        // module_init  module_exit
  2 #include &lt;linux/init.h&gt;            // __init   __exit
  3 #include &lt;linux/fs.h&gt;
  4 #include &lt;linux/leds.h&gt;
  5 #include &lt;mach/regs-gpio.h&gt;
  6 #include &lt;mach/gpio-bank.h&gt;
  7 #include &lt;linux/io.h&gt;
  8 #include &lt;linux/ioport.h&gt;
  9 #include &lt;mach/gpio.h&gt;
 10 #include &lt;linux/platform_device.h&gt;
 11
 12 // 定义一个结构体用于放置本设备的私有数据
 13 struct x210_led_platdata {
 14     unsigned int gpio;    // led设备用到的GPIO
 15     char *device_name;    // led设备在/sys/class/leds/目录下的名字
 16     char *gpio_name;      // 使用gpiolob申请gpio资源时分配的名字
 17 };
 18
 19
 20 // 定义x210_led_platdata类型的变量，分别对应板子上的4颗led小灯
 21 static struct x210_led_platdata x210_led1_pdata = {
 22     .gpio = S5PV210_GPJ0(3),
 23     .device_name = "led1",
 24     .gpio_name = "led1-gpj0_3",
 25 };
 26
 27 static struct x210_led_platdata x210_led2_pdata = {
 28     .gpio = S5PV210_GPJ0(4),
 29     .device_name = "led2",
 30     .gpio_name = "led2-gpj0_4",
 31 };
 32
 33 static struct x210_led_platdata x210_led3_pdata = {
 34     .gpio = S5PV210_GPJ0(5),
 35     .device_name = "led3",
 36     .gpio_name = "led3-gpj0_5",
 37 };
 38
 39 static struct x210_led_platdata x210_led4_pdata = {
 40     .gpio = S5PV210_GPD0(1),
 41     .device_name = "led4",
 42     .gpio_name = "led4-gpd0_1",
 43 };
 44
 45
 46 // 定义4个release函数，当我们卸载设备时会调用platform_device结构体中的device结构体下的release函数
 47 void x210_led1_release(struct device *dev)
 48 {
 49     printk(KERN_INFO "x210_led1_release\n");
 50 }
 51
 52 void x210_led2_release(struct device *dev)
 53 {
 54     printk(KERN_INFO "x210_led1_release\n");
 55 }
 56
 57 void x210_led3_release(struct device *dev)
 58 {
 59     printk(KERN_INFO "x210_led1_release\n");
 60 }
 61
 62 void x210_led4_release(struct device *dev)
 63 {
 64     printk(KERN_INFO "x210_led1_release\n");
 65 }
 66
 67
 68 // 定义4个platform_device结构体
 69 static struct platform_device x210_led1 = {
 70     .name        = "x210_led",
 71     .id        = 0,
 72     .dev        = {
 73         .platform_data    = &amp;x210_led1_pdata,
 74         .release = x210_led1_release,
 75     },
 76 };
 77
 78 static struct platform_device x210_led2 = {
 79     .name        = "x210_led",
 80     .id        = 1,
 81     .dev        = {
 82         .platform_data    = &amp;x210_led2_pdata,
 83         .release = x210_led2_release,
 84     },
 85 };
 86
 87 static struct platform_device x210_led3 = {
 88     .name        = "x210_led",
 89     .id        = 2,
 90     .dev        = {
 91         .platform_data    = &amp;x210_led3_pdata,
 92         .release = x210_led3_release,
 93     },
 94 };
 95
 96 static struct platform_device x210_led4 = {
 97     .name        = "x210_led",
 98     .id        = 3,
 99     .dev        = {
100         .platform_data    = &amp;x210_led4_pdata,
101         .release = x210_led4_release,
102     },
103 };
104
105
106 // 将4个platform_device结构体地址放入一个数组中
107 static struct platform_device *x210_devices[] = {
108     &amp;x210_led1,
109     &amp;x210_led2,
110     &amp;x210_led3,
111     &amp;x210_led4,
112 };
113
114 // 入口函数
115 static int __init leds_x210_init(void)
116 {
117     if (platform_add_devices(x210_devices, ARRAY_SIZE(x210_devices)))  // 循环注册platform平台设备
118     {
119         printk(KERN_ERR "platform_add_devices failed.\n");
120         return -1;
121     }
122
123     return 0;
124 }
125
126 // 出口函数（卸载）
127 static void __exit leds_x210_exit(void)
128 {
129     int i = 0;
130     for (i = 0; i &lt; 4; i++)
131        platform_device_unregister(x210_devices[i]);    // 当执行到这个函数的时候就会去执行platform_device结构体中的device结构体下的release函数
132 }
133
134 /*函数入口和出口修饰*/
135 module_init(leds_x210_init);
136 module_exit(leds_x210_exit);
137
138 /*描述模块信息*/
139 MODULE_LICENSE("GPL");                // 描述模块的许可证
140 MODULE_AUTHOR("Tao Deng &lt;&gt; [email&#160;protected]");            // 描述模块的作者
141 MODULE_DESCRIPTION("led device for x210.");    // 描述模块的介绍信息
142 MODULE_ALIAS("alias DT");            // 描述模块的别名信息</pre>
<p>device</p>
<p>(2)驱动部分：leds-x210-driver.c</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuYmxvZ3MuY29tL091dGxpbmluZ0luZGljYXRvcnMvQ29udHJhY3RlZEJsb2NrLmdpZg==.jpg"><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuYmxvZ3MuY29tL091dGxpbmluZ0luZGljYXRvcnMvRXhwYW5kZWRCbG9ja1N0YXJ0LmdpZg==.jpg"></p>

<pre>  1 #include &lt;linux/module.h&gt;        // module_init  module_exit
  2 #include &lt;linux/init.h&gt;            // __init   __exit
  3 #include &lt;linux/fs.h&gt;
  4 #include &lt;linux/leds.h&gt;
  5 #include &lt;mach/regs-gpio.h&gt;
  6 #include &lt;mach/gpio-bank.h&gt;
  7 #include &lt;linux/io.h&gt;
  8 #include &lt;linux/ioport.h&gt;
  9 #include &lt;mach/gpio.h&gt;
 10 #include &lt;linux/platform_device.h&gt;
 11 #include &lt;linux/slab.h&gt;
 12
 13 enum LED{
 14     LED_ON_ = 0,
 15     LED_OFF_ = 1,
 16 };
 17
 18 struct x210_led_platdata {
 19     unsigned int gpio;
 20     char *device_name;
 21     char *gpio_name;
 22 };
 23
 24 struct x210_platform {
 25     struct led_classdev led_class;
 26     unsigned int gpio;
 27 };
 28
 29 static inline struct x210_platform *pdev_to_gpio(struct platform_device *dev)
 30 {
 31     return platform_get_drvdata(dev);
 32 }
 33
 34 static void x210_led_set(struct led_classdev *led_cdev, enum led_brightness brightness)
 35 {
 36     struct x210_platform *pdata = container_of(led_cdev, struct x210_platform, led_class);  // 使用led_classdev结构体反推得到x210_platform结构体
 37
 38     if (0 &lt; brightness)
 39         gpio_set_value(pdata-&gt;gpio, LED_ON_);       // 使led小灯发亮
 40     else
 41         gpio_set_value(pdata-&gt;gpio, LED_OFF_);      // 使led小灯熄灭
 42 }
 43
 44 static int x210_led_probe(struct platform_device *dev)
 45 {
 46     // 定义变量
 47     int ret = 0;
 48     struct x210_led_platdata *platdata = dev-&gt;dev.platform_data;
 49     struct x210_platform *pform = NULL;
 50
 51     // 分配空间
 52     pform = kzalloc(sizeof(struct x210_platform), GFP_KERNEL);    // 将pform指针指向系统分配的地址空间
 53     if (NULL == pform) {
 54         printk(KERN_ERR "kzalloc failed.\n");
 55         return -ENOMEM;
 56     }
 57
 58     platform_set_drvdata(dev, pform);    // 将pform值写入到传进来的platform_device结构体中的device结构体下的私有数据区中去，以便后面释放内存时用
 59
 60     //驱动框架接口填充
 61     pform-&gt;led_class.name = platdata-&gt;device_name;
 62     pform-&gt;led_class.brightness = 0;
 63     pform-&gt;led_class.brightness_set = x210_led_set;
 64
 65     // 保存gpio管脚信息
 66     pform-&gt;gpio = platdata-&gt;gpio;
 67
 68     //注册led驱动
 69     ret =  led_classdev_register(NULL, &amp;pform-&gt;led_class);
 70     if (ret &lt; 0) {
 71         printk(KERN_ERR "led_classdev_register failed.\n");
 72         goto err_led_classdev_register;
 73     }
 74
 75     // 向gpiolib管理器申请gpio资源
 76     if (gpio_request(platdata-&gt;gpio, platdata-&gt;gpio_name))
 77     {
 78         printk(KERN_ERR "gpio_request failed.\n");
 79         goto err_gpio_request;
 80     }
 81
 82     // 设置GPIO输出高电平，关闭LED
 83     gpio_direction_output(platdata-&gt;gpio, LED_OFF_);
 84
 85     printk(KERN_INFO "x210_led_probe succeseful.\n");
 86
 87     return 0;
 88
 89 err_gpio_request:
 90     led_classdev_unregister(&amp;pform-&gt;led_class);
 91
 92 err_led_classdev_register:
 93
 94     return -1;
 95 }
 96
 97 static int x210_led_remove(struct platform_device *dev)
 98 {
 99     struct x210_led_platdata *platdata = dev-&gt;dev.platform_data;
100     struct x210_platform *pform = pdev_to_gpio(dev);     // 取出platform_device结构体中的device结构体中的私有数据区的x210_platform指针
101
102     // 卸载led驱动
103     led_classdev_unregister(&amp;pform-&gt;led_class);
104
105     // 关闭所有led
106     gpio_set_value(platdata-&gt;gpio, LED_OFF_);
107
108     // 释放申请的GPIO资源
109     gpio_free(platdata-&gt;gpio);
110
111     // 释放内存
112     kfree(pform);         // 这个一定要放在最后
113
114     printk(KERN_INFO "x210_led_remove succeseful.\n");
115
116     return 0;
117 }
118
119 static struct platform_driver x210_led_driver = {
120     .probe        = x210_led_probe,
121     .remove        = x210_led_remove,
122     .driver        = {
123         .name        = "x210_led",
124         .owner        = THIS_MODULE,
125     },
126 };
127
128 static int __init leds_x210_init(void)
129 {
130     int ret = 0;
131
132     ret = platform_driver_register(&amp;x210_led_driver);
133     if (ret)
134        printk(KERN_ERR "platform_driver_register failed.\n");
135
136     return ret;
137 }
138
139 static void __exit leds_x210_exit(void)
140 {
141     platform_driver_unregister(&amp;x210_led_driver);
142 }
143
144 /*函数入口和出口*/
145 module_init(leds_x210_init);
146 module_exit(leds_x210_exit);
147
148 /*描述模块信息*/
149 MODULE_LICENSE("GPL");                // 描述模块的许可证
150 MODULE_AUTHOR("Tao Deng &lt;&gt; [email&#160;protected]");            // 描述模块的作者
151 MODULE_DESCRIPTION("led driver for x210.");    // 描述模块的介绍信息
152 MODULE_ALIAS("alias DT");            // 描述模块的别名信息</pre>
<p>driver</p>
<p>3、platform总线工作原理</p>
<p>(1)insmod之后的现象</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzk0NDg5My8yMDE2MTEvOTQ0ODkzLTIwMTYxMTA1MTg0OTI0Mjk5LTYyNTM4MTA4OS5wbmc=.jpg"></p>
<p>当我们执行第一个insmod的时候，并没有出现后面的4条打印信息，只是执行了leds_x210_init函数（一次insmod只能对应执行一次xxx_init函数，</p>
<p>一次rmmod只能对应执行一次xxx_exit函数），这里并没有放置打印语句的信息，因为此时匹配并不会成功，所以不会执行驱动层probe函数；</p>
<p>而当执行第二个insmod的时候，此时platform总线下的match函数匹配就会成功，因为对应有4个led设备，所以就会匹配4次，执行了4次probe</p>
<p>函数打印出相应的信息。</p>
<p>(2)rmmod时的现象</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzk0NDg5My8yMDE2MTEvOTQ0ODkzLTIwMTYxMTA1MTkwMzM4NTE4LTI4MTE3MzQ3My5wbmc=.jpg"></p>
<p>当我们卸载调驱动或者是设备中的任何一个，都会执行驱动层的remove函数；如果是先rmmod设备，那么先执行驱动层中的remove函数，之后就</p>
<p>会执行设备层中的platform_device结构体中的device结构体下的release函数，每一个设备都会执行一次，因为这里卸载了4个设备，所以就会执行</p>
<p>4次；如果是先rmmod驱动，那么直接就会执行驱动层的remove函数</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-20 07:15:39 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/back/" title="back">back</a>, <a href="https://www.biecuoliao.com/tag/linux/" title="linux">linux</a>, <a href="https://www.biecuoliao.com/tag/info/" title="info">info</a>, <a href="https://www.biecuoliao.com/tag/val/" title="val">val</a>, <a href="https://www.biecuoliao.com/tag/%e7%bb%93%e6%9e%84/" title="结构">结构</a>, <a href="https://www.biecuoliao.com/tag/ted/" title="ted">ted</a>, <a href="https://www.biecuoliao.com/tag/%e6%a8%a1%e5%9e%8b/" title="模型">模型</a>, <a href="https://www.biecuoliao.com/tag/%e5%88%86%e9%85%8d/" title="分配">分配</a>, <a href="https://www.biecuoliao.com/tag/_exit%e5%87%bd%e6%95%b0/" title="&lowbar;exit函数">&lowbar;exit函数</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>platform总线驱动代码分析的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4pbBZV0.html" rel="bookmark">linux驱动之i2c总线驱动调用分析【基于linux4&period;4】</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				平台:RK3399 使用设备树描述板级资源: 框架: linux i2c框架同样采用分层.分离的模式设计:从上到下分为  app调用层.i2c core层.驱动层:驱动层又分为 cpu平台 i2c控制器相关的驱动层以及 i2c总线上挂接的设备驱动程序:而分离的思想则体现在板级相关的信息放在设备树上实现,而通用的读写.初始化流程.操作流程等则放到驱动里面实现(类似platform总线驱动): 具体分析: 1. cpu i2c控制器驱动(adpter) static struct platform_			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MP9O2P0.html" rel="bookmark">Linux时间子系统&lpar;十七&rpar; ARM generic timer驱动代码分析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.前言 关注ARM平台上timer driver(clocksource chip driver和clockevent chip driver)的驱动工程师应该会注意到timer硬件的演化过程.在单核时代,各个SOC vendor厂商购买ARM core的IP,然后自己设计SOC上的peripherals,这里面就包括了timer的硬件.由于没有统一的标准,各个厂商的设计各不相同,这给驱动工程师带来了工作量.然而,如果仅仅是工作量的话就还好,实际上,不仅仅如此.linux的时间子系统要求硬件t			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/41mJpY4.html" rel="bookmark">I2C总线驱动代码</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				通过上篇对I2C总线的介绍,那面,接下来就需要软件部分针对I2C总线的编程实现. 具体细细道来,(前提是,已经找好两个IO口分别为SDA SCL) 1.1st function: I2c start void IIC_Start(void) { SDA_OUTPUT(); SET_SDA(); usleep(4); SET_SCL(); usleep(6); CLR_SDA(); usleep(4); } 2. 2nd :I2c stop void IIC_Stop (void) { uslee			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MPZbNv3.html" rel="bookmark">驱动04&period;平台总线驱动模型&mdash;&mdash;点亮LED灯</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1 平台总线的简介 平台总线是一种虚拟的总线,相应的设备则为platform_device,而驱动则为platform_driver.总线将设备和驱动绑定,在系统每注册一个设备的时候,会寻找与之匹配的驱动:相反的,在系统每注册一个驱动的时候,会寻找与之匹配的设备,而匹配由总线完成. 我们可以把一个驱动程序抽出来分为两部分,一部分是硬件相关的dev,另一部分则是稳定的纯软件部分driver.而总线只是一种机制,把dev和driver这两部分建立&quot;联系&quot;的机制. eg: ①dev部分 a.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3q1lR53.html" rel="bookmark">platform设备驱动全透析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原创作品,允许转载,转载时请务必以超链接形式标明文章 原始出处 .作者信息和本声明.否则将追究法律责任.http://21cnbao.blog.51cto.com/109393/337609 1.1 platform总线.设备与驱动 在Linux 2.6的设备驱动模型中,关心总线.设备和驱动这3个实体,总线将设备和驱动绑定.在系统每注册一个设备的时候,会寻找与之匹配的驱动:相反的,在系统每注册一个驱动的时候,会寻找与之匹配的设备,而匹配由总线完成. 一个现实的Linux设备和驱动通常都需要挂接在			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4QAxA24.html" rel="bookmark">Linux网卡驱动架构分析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.网卡驱动架构 由上到下层次依次为:应用程序→系统调用接口→协议无关接口→网络协议栈→设备无关接口→设备驱动. 二.重要数据结构 1.Linux内核中每一个网卡由一个net_device结构来描述. 2.网卡操作函数集:net_device_ops,这个数据结构是上面net_device的一个成员. 3.网络数据包:sk_buff. 三.网卡驱动代码分析 所用文件为cs89x0.c,主要分析三个部分:网卡初始化.发送数据.接收数据. ㈠网卡初始化 网卡驱动初始化主要在函数init_module			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0lk8rZM.html" rel="bookmark">SylixOS iMX6平台I2C总线驱动</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原理概述 I2C总线驱动概述 I2C总线驱动是I2C适配器的软件实现,提供I2C适配器与从设备间完成数据通信的能力,比如起始,停止,应答信号和MasterXfer的实现函数.驱动程序包含初始化I2C总线控制器__i2cHwInit函数,操作函数集(总线传输__i2cTransfer函数,总线控制__i2cMasterCtl函数). Imx6ul控制器的硬件描述 imx6ul处理器内部集成了一个I2C控制器,通过五个寄存器来进行控制. I2Cx_IADR I2C地址寄存器 I2Cx_IFDR I2			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0eZZV53.html" rel="bookmark">Linux驱动中的platform总线分析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				copy from :https://blog.csdn.net/fml1997/article/details/77622860 概述 从Linux2.6内核起,引入一套新的驱动管理和注册机制:platform_device 和 platform_driver .Linux 中大部分的设备驱动,都可以使用这套机制,设备用 platform_device 表示:驱动用 platform_driver 进行注册. linux_platform_driver 机制和传统的device_driver机			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0RQPnYM.html" rel="bookmark">platform设备驱动框架搭建分析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				之前接触到的字符设备驱动是非常单纯的Linux字符设备驱动,他不具备工程中Linux驱动中的设备与驱动分离思想和设备驱动的分层思想,不具备&quot;总线-设备-驱动&quot;模型的概念.接下来通过分析platform设备驱动模型的搭建过程来看看Linux的设备驱动模型究竟是怎样的? platform驱动模型搭建: (1)platform核心层:为设备层和驱动层提供注册接口.为设备层和驱动层的匹配提供标准 ①搭建总线框架: 总线类结构体: struct bus_type { const char *na			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/W0jGK93.html" rel="bookmark" class="title">JavaScript事件详解</a>
					<div>
						事件流 描述的是在页面中接收事件的顺序 事件冒泡 由最具体的元素接收,然后逐级向上传播至最不具体的元素的节点(文档) 事件捕获 最不具体的节点先接收事件,而最具体的节点应该是最后接收事件 事件处理 H ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0eADwZ0.html" rel="bookmark" class="title">使用NuGet Package Project快速制作NuGet包</a>
					<div>
						今天在visual studio gallery发现了一个插件NuGet Package Project,通过它可以在Visual Studio中建立Nuget Package工程,直接生成Nuget ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0Ka9B94.html" rel="bookmark" class="title">Android图片360全景旋转</a>
					<div>
						============问题描述============ 我在网上找到关于Android全景图片旋转的demo,经测试也可以用http://download.csdn.net/detail/a3942 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/49b9GDM.html" rel="bookmark" class="title">学习历程（记录大学学习，电子信息科学类）</a>
					<div>
						(目标:嵌入式) 学校授课 高数/线性代数 电路基础 模电 数电 微机原理(8086) 高频 C语言 vc++ eda 其他  :通信原理,数字信号处理 自学 Java(基础) c#(基础) 安卓应用 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/02DLNa4.html" rel="bookmark" class="title">JS学习笔记2015-4-15（第二天）</a>
					<div>
						二(接14号).JS属性操作的注意事项: 1.所有的相对路径,都不要拿来做判断:也就是相对路径不可以拿来读取(但是可以写操作) 2.颜色值也不要拿来做判断(会有兼容性问题): 3.innerHTML值 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rEkk70.html" rel="bookmark" class="title">&lbrack;Android&rsqb; TextSwitcher -- 做什么的</a>
					<div>
						TextSwitcher的Java Doc是这样描述自己的: Specialized ViewSwitcher that contains only children of type TextView ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MgZmVB4.html" rel="bookmark" class="title">RT-WiFi驱动配置</a>
					<div>
						RT-WiFi在最后配置的时候: 1. rt-wifi-sched.h文件中static struct rt-wifi_sta RT-WIFI_STAS[]={ {. mac_addr = {0x00 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YR9gX3.html" rel="bookmark" class="title">Java FastJson 源码分析&lpar;一&rpar; 之 简单应用</a>
					<div>
						fastjson是一个性能很好的Java语言实现的JSON解析器和生成器,来自阿里的工程师开发.提供了Java对象快速序列化和发序列化的工具. 主要特点: ?快速FAST(比其它任何基于Java的解析 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLvrWQ3.html" rel="bookmark" class="title">全新ASP框架&mdash;&mdash;IISNODE介绍</a>
					<div>
						Asp是一门经典的动态网页编程语言,通常使用vbscript或者Jscript脚本来实现.一个好的框架,可以帮助您更加快速地使用Asp来完成您的网站开发任务.而Asp框架的终结者——IISNODE框架 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0j2gGg0.html" rel="bookmark" class="title">查找与排序05&comma;冒泡排序</a>
					<div>
						在体验了&quot;选择排序&quot;和&quot;插入排序&quot;,本篇体验的是&quot;冒泡排序&quot;,依次遍历数组中的元素,按照升序排列,如果前一个位置元素比后一个位置元素大,两者 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVq5Rp4.html" rel="bookmark" class="title">jQuery实现弹出框拖拽</a>
					<div>
						主要应用jQuery的on和off方法实现在 mousedown 的情况下进行mousemove. 其他:$(window).width() .$(window).height() ---- 获取浏览 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLRzkd3.html" rel="bookmark" class="title">JVM中的堆和栈</a>
					<div>
						栈是运行时的单位,而堆是存储的单位. 栈解决程序的运行问题,即程序如何执行,或者说如何处理数据:堆解决的是数据存储的问题,即数据怎么放.放在哪儿. 在Java中一个线程就会相应有一个线程栈与之对应,这 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kllw73.html" rel="bookmark" class="title">&lbrack;Tjoi2016&amp;amp&semi;Heoi2016&rsqb;字符串</a>
					<div>
						[Tjoi2016&amp;Heoi2016]字符串 题目 佳媛姐姐过生日的时候,她的小伙伴从某东上买了一个生日礼物.生日礼物放在一个神奇的箱子中.箱子外边写了一个长为n的字符串s,和m个问题.佳媛姐 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzkbZ80.html" rel="bookmark" class="title">&num;4&period;Git版本回滚</a>
					<div>
						实际工作中,我们脑子里怎么可能记得一个几千行的文件每次都改了什么内容,不然要版本控制系统干什么.版本控制系统肯定有某个命令可以告诉我们历史记录, &gt;1.在Git中,我们用git log命令查看: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDjPGn3.html" rel="bookmark" class="title">PXE 装机详解</a>
					<div>
						PXE 装机详解 =========================================================================== 概述: 在实际工作中,我们经常 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3OXxw84.html" rel="bookmark" class="title">动态规划-uva-674</a>
					<div>
						uva-674- Coin Change Suppose there are 5 types of coins: 50-cent, 25-cent, 10-cent, 5-cent, and 1-ce ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWQBg63.html" rel="bookmark" class="title">&lowbar;&lowbar;attribute&lowbar;&lowbar; 你知多少？</a>
					<div>
						引用原文地址是: http://www.cnblogs.com/astwish/p/3460618.html GNU C 的一大特色就是__attribute__ 机制.__attribute__ 可 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXGgyq4.html" rel="bookmark" class="title">诗词十四首</a>
					<div>
						张 嵩 罗山 风起荒原草木喧,春光一路上罗山. 岩石俊俏惊心底,鸟道崎岖挽手边. 久居城中无眼界,偶来世外有诗篇. 不为寻索常烦闷,纵目青峰阅九天. 2014年5月 青云寺 钟声悠远每相闻,老树枝头落 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0e8pGwM.html" rel="bookmark" class="title">理解position与anchorPoint［转］</a>
					<div>
						引言 相信初接触到CALayer的人都会遇到以下几个问题:  为什么修改anchorPoint会移动layer的位置? CALayer的position点是哪一点呢? anchorPoint与posi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWvypa4.html" rel="bookmark" class="title">【转】IGBT变频电源在汽车曲轴淬火中的应用</a>
					<div>
						1 前言 当代的感应热处理技术具有优质.高效.环保等诸多特点,符合现代汽车生产需要,因而得到广泛应用.作为感应热处理技术基础的变频器的IGBT模块已商品化,在我国感应加热领域已成功生产出10-100  ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.031 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
